package xyz.mtfos.btdemo

import android.app.Activity
import android.os.Bundle
import android.os.Handler
import android.widget.Button
import android.widget.EditText
import xyz.mtfos.btdemo.objectTool.bind

/**
 * Created by jay on 2017/8/9.
 */
class MainActivity : Activity() {
    val intxt: EditText by bind(R.id.intxt)
    val btn: Button by bind(R.id.bt)
    val connectBtn: Button by bind(R.id.connect)
    val disconnectBtn: Button by bind(R.id.disconnect)
    var ble: BLECls? = null
    val uiHandler: Handler = Handler()
    var th: Thread? = null
    var thrun: Boolean = false
    var isInit: Boolean = false

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        btn.isEnabled = false
        connectBtn.isEnabled = true
        disconnectBtn.isEnabled = false

        ble = BLECls(this@MainActivity)

        btn.setOnClickListener {
            val txt: String = intxt.text.toString()
            ble?.sendLongData(txt.toByteArray())
        }

        connectBtn.setOnClickListener {
            scanConnect()
        }
        disconnectBtn.setOnClickListener {
            disconnect()
        }
    }

    override fun onStop() {
        super.onStop()
        disconnect()
    }

    fun scanConnect(){
        if (ble?.init()!!) {
            isInit = true
            ble?.startScan()
        }

        th = Thread(Runnable {
            thrun = true
            while (thrun) {
                System.out.println("state ===== " + ble?.mState)
                if (ble?.mState == ble?.CONNECTED) {
                    uiHandler.post {
                        btn.isEnabled = true
                        disconnectBtn.isEnabled = true
                        connectBtn.isEnabled = false
                    }
                    thrun = false
                    break
                }
                Thread.sleep(200)
            }
        })
        th?.start()
    }

    fun disconnect() {
        thrun = false
        if (ble?.isScanning!!) {
            ble?.stopScan()
        }
        if (ble?.mState == ble?.CONNECTED) {
            ble?.disconnect()
        }
        disconnectBtn.isEnabled = false
        connectBtn.isEnabled = true
    }
}